Subject: Re: [PATCH 04/10] 8xx: Always pin kernel instruction TLB

From: Roland Dreier <[email-masked]>
Date: Sat, 14 Nov 2009 22:49:47 -0800

> > How to make better use of the remaining ITLB slots is tricky.
 > > Somehow one would want to map at lest one to modules but I cannot see how.
 > 
 > No. If you use modules, you pay the price. Sane embedded solutions
 > running in "tight" environments don't use modules :-) No point pinning
 > TLB entries on the vmalloc space, really.

Long ago (2.4 days I think) when using modules on ppc 4xx we hacked the
module_alloc function (or whatever it was called back then) to allocate
space in the kernel pinned TLB instead of using vmalloc.  Gave something
like a 2x speedup for module code, since the 4xx TLB is so small and the
miss handling is so expensive.  I assume it should still be possible to
do a similar hack with current kernels.

 - R.